#ifndef LIGO_DAC_INFO_H
#define LIGO_DAC_INFO_H

#include "portableInline.h"
#include "drv/cdsHardware.h" //CDS_HARDWARE
#include "cds_types.h" //dacInfo_t
#include "controller.h" //cdsPciModules

#ifdef __cplusplus
extern "C" {
#endif

LIGO_INLINE int
dac_status_update( dacInfo_t* dacinfo )
{
    int ii, jj;
    int status = 0;

    for ( jj = 0; jj < cdsPciModules.dacCount; jj++ )
    {
        if ( dacinfo->dacOF[ jj ] )
        {
            pLocalEpics->epicsOutput.statDac[ jj ] &= ~( DAC_OVERFLOW_BIT );
            status |= FE_ERROR_OVERFLOW;

        }
        else
            pLocalEpics->epicsOutput.statDac[ jj ] |= DAC_OVERFLOW_BIT;

        dacinfo->dacOF[ jj ] = 0;

        if ( dacChanErr[ jj ] ) {
            pLocalEpics->epicsOutput.statDac[ jj ] &= ~( DAC_TIMING_BIT );
        }
        else {
            pLocalEpics->epicsOutput.statDac[ jj ] |= DAC_TIMING_BIT;
        }

        dacChanErr[ jj ] = 0;

        for ( ii = 0; ii < MAX_DAC_CHN_PER_MOD; ii++ )
        {

            if ( pLocalEpics->epicsOutput.overflowDacAcc[ jj ][ ii ] >
                 OVERFLOW_CNTR_LIMIT )
            {
                pLocalEpics->epicsOutput.overflowDacAcc[ jj ][ ii ] = 0;
            }
            pLocalEpics->epicsOutput.overflowDac[ jj ][ ii ] =
                dacinfo->overflowDac[ jj ][ ii ];
            dacinfo->overflowDac[ jj ][ ii ] = 0;
        }
    }
    return status;
}

#ifdef __cplusplus
}
#endif



#endif //LIGO_DAC_INFO_H
